> ## Documentation Index
> Fetch the complete documentation index at: https://docs.mangopay.com/llms.txt
> Use this file to discover all available pages before exploring further.

# View a Refund

<Note>
  **Note – Refund data retained for 13 months**

  The API retains all transaction objects for 13 months from `CreationDate`. This applies to refunds and the initial transaction linked to a refund.

  A call to retrieve the initial transaction of a refund, based on the refund’s `InitialTransactionId`, may return a 404 Not Found if it occurred more than 13 months ago.

  For more information, see the <a href="/api-reference/overview/data-availability-periods">Data availability periods</a> article.
</Note>

### Responses

<AccordionGroup>
  <Accordion title="200" defaultOpen>
    <ResponseField name="Id" type="string">
      Max length: 128 characters (see [data formats](/api-reference/overview/data-formats) for details)

      The unique identifier of the object.
    </ResponseField>

    <ResponseField name="Tag" type="string">
      Max. length: 255 characters

      Custom data that you can add to this object.\
      For transactions (pay-in, transfer, payout), you can use this parameter to identify corresponding information regarding the user, transaction, or payment methods on your platform.
    </ResponseField>

    <ResponseField name="CreationDate" type="Unix timestamp">
      The date and time at which the object was created.
    </ResponseField>

    <ResponseField name="AuthorId" type="string">
      The unique identifier of the user at the source of the initial transaction.
    </ResponseField>

    <ResponseField name="CreditedUserId" type="string">
      **Default value:** The unique identifier of the owner of the credited wallet.

      The unique identifier of the user whose wallet is credited.
    </ResponseField>

    <ResponseField name="DebitedFunds" type="object">
      **Default value:** The amount and currency values of the debited funds of the initial transaction.

      Information about the debited funds. Debited funds:

      * Takes by default the amount and currency values of the initial transaction when left empty.
      * Must be entered manually to perform a partial refund.
      * Cannot exceed the initial transaction `CreditedFunds` value when entered manually. This also applies to the sum of debited funds when making multiple partial refunds.

      <Expandable title="properties">
        <ResponseField name="Amount" type="integer">
          An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
        </ResponseField>

        <ResponseField name="Currency" type="string">
          **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

          The currency of the debited funds.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="CreditedFunds" type="object">
      Information about the credited funds (`CreditedFunds` = `DebitedFunds` - `Fees`).

      <Expandable title="properties">
        <ResponseField name="Currency" type="string">
          **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

          The currency of the credited funds.
        </ResponseField>

        <ResponseField name="Amount" type="integer">
          An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="Fees" type="object">
      **Default value:** The amount and currency values of the fees of the initial transaction.

      Information about the fees. This value:

      * Should be preceded by a minus sign (-) to refund the fees, otherwise more fees will be taken.
      * Takes by default the amount and currency values of the fees of the initial transaction when left empty (preceded by a -).
      * Cannot exceed the initial transaction fees amount when entered manually. This also applies to the sum of the amount of the fees when making multiple partial refunds.

      <Expandable title="properties">
        <ResponseField name="Amount" type="integer">
          An amount of money in the smallest sub-division of the currency (e.g., EUR 12.60 would be represented as `1260` whereas JPY 12 would be represented as just `12`).
        </ResponseField>

        <ResponseField name="Currency" type="string">
          **Returned values:** The three-letter <a href="/api-reference/overview/data-formats" target="_blank">ISO 4217 code</a> (EUR, GBP, etc.) of a <a href="/guides/currencies" target="_blank">supported currency</a> (depends on feature, contract, and activation settings).

          The currency of the debited funds.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="Status" type="string">
      **Returned values:** `CREATED`, `SUCCEEDED`, `FAILED`

      The status of the transaction.
    </ResponseField>

    <ResponseField name="ResultCode" type="string">
      The code indicating the result of the operation. This information is mostly used to <a href="/errors/codes">handle errors</a> or for filtering purposes.
    </ResponseField>

    <ResponseField name="ResultMessage" type="string">
      The explanation of the result code.
    </ResponseField>

    <ResponseField name="ExecutionDate" type="Unix timestamp">
      The date and time at which the status changed to `SUCCEEDED`, indicating that the transaction occurred. The statuses `CREATED` and `FAILED` return an `ExecutionDate` of `null`.
    </ResponseField>

    <ResponseField name="Type" type="string">
      **Returned values:** `PAYIN`, `TRANSFER`, `CONVERSION`, `PAYOUT`

      The type of the transaction.
    </ResponseField>

    <ResponseField name="Nature" type="string">
      **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT`

      The nature of the transaction, providing more information about the context in which the transaction occurred:

      * `REGULAR` – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow.
      * `REPUDIATION` – Automatic withdrawal of funds from the platform’s repudiation wallet as part of the dispute process (when the user has requested a chargeback).
      * `REFUND` – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay).
      * `SETTLEMENT` – Transfer made to the repudiation wallet by the platform to settle a lost dispute.
    </ResponseField>

    <ResponseField name="InitialTransactionId" type="string">
      The unique identifier of the initial transaction being refunded.
    </ResponseField>

    <ResponseField name="InitialTransactionType" type="string">
      **Returned values:** `PAYIN`, `TRANSFER`, `PAYOUT`

      The type of the initial transaction being refunded.
    </ResponseField>

    <ResponseField name="InitialTransactionNature" type="string">
      **Returned values:** `REGULAR`, `REPUDIATION`, `REFUND`, `SETTLEMENT`

      The nature of the initial transaction being refunded, providing more information about the context in which the transaction occurred:

      * REGULAR – Relative to most of the transactions (pay-ins, payouts, and transfers) in a usual workflow.
      * REPUDIATION – Automatic withdrawal of funds from the platform’s repudiation wallet as part of the dispute process (when the user requested a chargeback).
      * REFUND – Reimbursement of a transaction to the user (pay-in refund), to a wallet (transfer refund), or of a payout (payout refund, only initiated by Mangopay).
      * SETTLEMENT – Transfer made to the repudiation wallet by the platform to settle the credit from a repudiation following a lost dispute.
    </ResponseField>

    <ResponseField name="DebitedWalletId" type="string">
      The unique identifier of the debited wallet.
    </ResponseField>

    <ResponseField name="CreditedWalletId" type="string">
      The unique identifier of the credited wallet.
    </ResponseField>

    <ResponseField name="RefundReason" type="object">
      Information about the reasons for the refund.

      <Expandable title="properties">
        <ResponseField name="RefundReasonMessage" type="string">
          Max. length: 255 characters

          Message explaining the reason for the refusal.
        </ResponseField>

        <ResponseField name="RefundReasonType" type="string">
          **Returned values:** `INITIALIZED_BY_CLIENT`, `BANKACCOUNT_INCORRECT`, `OWNER_DO_NOT_MATCH_BANKACCOUNT`, `BANKACCOUNT_HAS_BEEN_CLOSED`, `WITHDRAWAL_IMPOSSIBLE_ON_SAVINGS_ACCOUNTS`, `OTHER`

          The type of reason for the refund.
        </ResponseField>
      </Expandable>
    </ResponseField>

    <ResponseField name="StatementDescriptor" type="string">
      Max. length: 10 characters; only alphanumeric and spaces

      Custom description to appear on the user’s bank statement along with the platform name. Different banks may show more or less information. See the <a href="/bank-statements">Customizing bank statement references</a> article for details.

      **Note:** On refunds, the `StatementDescriptor` is only available for SEPA and BACS <a href="/api-reference/direct-debit-payins/create-direct-debit-payin">direct debit pay-ins</a> (no other payment methods nor transfers).
    </ResponseField>
  </Accordion>
</AccordionGroup>

<ResponseExample>
  ```json Pay-in refund theme={null}
  {
      "Id": "refund_m_01JJ23MDDHCXX1GYVKDPYNJKJ8",
      "Tag": "Example with fees refunded",
      "CreationDate": 1730373612,
      "AuthorId": "user_m_01JJ23MPT0Y79AFQA637ZK81CF",
      "CreditedUserId": null,
      "DebitedFunds": {
          "Currency": "EUR",
          "Amount": 500
      },
      "CreditedFunds": {
          "Currency": "EUR",
          "Amount": 550
      },
      "Fees": {
          "Currency": "EUR",
          "Amount": -50
      },
      "Status": "SUCCEEDED",
      "ResultCode": "000000",
      "ResultMessage": "Success",
      "ExecutionDate": 1730373612,
      "Type": "PAYOUT",
      "Nature": "REFUND",
      "InitialTransactionId": "payin_m_01JJ23NT128Y1V1B5B16VKMQ92",
      "InitialTransactionType": "PAYIN",
      "InitialTransactionNature": "REGULAR",
      "DebitedWalletId": "wlt_m_01JJ23NKD34XA6G4N70ZFKFH5W",
      "CreditedWalletId": null,
      "RefundReason": {
          "RefundReasonMessage": null,
          "RefundReasonType": "INITIALIZED_BY_CLIENT"
      },
      "StatementDescriptor": null
  }
  ```

  ```json Transfer refund theme={null}
  {
      "Id": "refund_m_01JJ24GYE8X6MMSR26F0A2VRR9",
      "Tag": "Example with fees taken",
      "CreationDate": 1737386006,
      "AuthorId": "user_m_01JJ24H7HV1H38GRCCY4Q8ZR85",
      "CreditedUserId": null,
      "DebitedFunds": {
          "Currency": "EUR",
          "Amount": 2000
      },
      "CreditedFunds": {
          "Currency": "EUR",
          "Amount": 1900
      },
      "Fees": {
          "Currency": "EUR",
          "Amount": 100
      },
      "Status": "SUCCEEDED",
      "ResultCode": "000000",
      "ResultMessage": "Success",
      "ExecutionDate": 1737386006,
      "Type": "TRANSFER",
      "Nature": "REFUND",
      "InitialTransactionId": "xfer_m_01JJ24NTCVFSPH5TK453Y623HF",
      "InitialTransactionType": "TRANSFER",
      "InitialTransactionNature": "REGULAR",
      "DebitedWalletId": "wlt_m_01JJ24P7QXT0W0F917DXNQF49S",
      "CreditedWalletId": "wlt_m_01JJ24PH51DAJR2H63BDCHSN84",
      "RefundReason": {
          "RefundReasonMessage": null,
          "RefundReasonType": "OTHER"
      },
      "StatementDescriptor": null
  }
  ```

  ```json Payout return theme={null}
  {
      "Id": "refund_m_01JJ22Z1JGMFEHB5P4B5DZ8CCQ",
      "Tag": null,
      "CreationDate": 1734628083,
      "AuthorId": "user_m_01JJ22ZEP6JQQ5KMBPHBGYFQBG",
      "CreditedUserId": null,
      "DebitedFunds": {
          "Currency": "EUR",
          "Amount": 12000
      },
      "CreditedFunds": {
          "Currency": "EUR",
          "Amount": 12000
      },
      "Fees": {
          "Currency": "EUR",
          "Amount": 0
      },
      "Status": "SUCCEEDED",
      "ResultCode": "000000",
      "ResultMessage": "Success",
      "ExecutionDate": 1734628084,
      "Type": "PAYIN",
      "Nature": "REFUND",
      "InitialTransactionId": "po_m_01JJ2303Q94M2SNSFEX4M3W3N0",
      "InitialTransactionType": "PAYOUT",
      "InitialTransactionNature": "REGULAR",
      "DebitedWalletId": null,
      "CreditedWalletId": "wlt_m_01JJ230JF16SKNVFR2FRPHEZWZ",
      "RefundReason": {
          "RefundReasonMessage": "AC04",
          "RefundReasonType": "BANKACCOUNT_HAS_BEEN_CLOSED"
      },
      "StatementDescriptor": null
  }
  ```

  ```json Repudiation return theme={null}
  {
      "Id": "refund_m_01JJ22PR01NMY4M8HXB3AW6KG7",
      "Tag": null,
      "CreationDate": 1737367609,
      "AuthorId": "user_m_01JJ22Q2A0NXNK26B67BD1MP4R",
      "CreditedUserId": "your-mangopay-client-id",
      "DebitedFunds": {
          "Currency": "EUR",
          "Amount": 13000
      },
      "CreditedFunds": {
          "Currency": "EUR",
          "Amount": 13000
      },
      "Fees": {
          "Currency": "EUR",
          "Amount": 0
      },
      "Status": "SUCCEEDED",
      "ResultCode": "000000",
      "ResultMessage": "Success",
      "ExecutionDate": 1737367609,
      "Type": "PAYIN",
      "Nature": "REFUND",
      "InitialTransactionId": "repud_m_01JJ22HPJ8Y0E4YW7D9XR96WZY",
      "InitialTransactionType": "PAYOUT",
      "InitialTransactionNature": "REPUDIATION",
      "DebitedWalletId": null,
      "CreditedWalletId": "CREDIT_EUR",
      "RefundReason": {
          "RefundReasonMessage": null,
          "RefundReasonType": "OTHER"
      },
      "StatementDescriptor": null
  }
  ```
</ResponseExample>

<RequestExample>
  ```json REST theme={null}
  // GET has no body parameters
  ```

  ```php PHP theme={null}
  <?php 

  require_once 'vendor/autoload.php';

  use MangoPay\MangoPayApi;
  use MangoPay\Libraries\ResponseException as MGPResponseException;
  use MangoPay\Libraries\Exception as MGPException;

  $api = new MangoPayApi();

  $api->Config->ClientId = 'your-client-id';
  $api->Config->ClientPassword = 'your-api-key';
  $api->Config->TemporaryFolder = 'tmp/';

  try {
      $refundId = '180925566';

      $response = $api->Refunds->Get($refundId);

      print_r($response);
  } catch(MGPResponseException $e) {
      print_r($e);
  } catch(MGPException $e) {
      print_r($e);
  }  
  ```

  ```javascript NodeJS   theme={null}
  const mangopayInstance = require('mangopay4-nodejs-sdk')
  const mangopay = new mangopayInstance({
      clientId: 'your-client-id',
      clientApiKey: 'your-api-key',
  })

  let myRefund = {
    Id: '180925566',
  }

  const viewRefund = async (refundId) => {
    return await mangopay.Refunds.get(refundId)
      .then((response) => {
        console.info(response)
        return response
      })
      .catch((err) => {
        console.log(err)
        return false
      })
  }

  viewRefund(myRefund.Id)  
  ```

  ```ruby Ruby   theme={null}
  require 'mangopay'

  MangoPay.configure do |client|
      client.preproduction = true
      client.client_id = 'your-client-id'
      client.client_apiKey = 'your-api-key'
      client.log_file = File.join(Dir.pwd, 'mangopay.log')
  end

  def viewRefund(refundId)
      begin
          response = MangoPay::Refund.fetch(refundId)
          puts response
          return response
      rescue MangoPay::ResponseError => error
          puts "Failed to fetch Refund: #{error.message}"
          puts "Error details: #{error.details}"
          return false
      end
  end

  myRefund = {
      Id: '180925566'
  }

  viewRefund(myRefund[:Id])  
  ```

  ```java Java theme={null}
  import com.google.gson.Gson;
  import com.google.gson.GsonBuilder;
  import com.mangopay.MangoPayApi;
  import com.mangopay.entities.Refund;

  public class ViewRefund {
      public static void main(String[] args) throws Exception {
          MangoPayApi mangopay = new MangoPayApi();
          mangopay.getConfig().setClientId("your-client-id");
          mangopay.getConfig().setClientPassword("your-api-key");

          var refundId = "refund_m_01J2BZ8BBT3GV20FZES1B5Z7TM";

          Refund viewRefund = mangopay.getRefundApi().get(refundId);

          Gson prettyPrint = new GsonBuilder().setPrettyPrinting().create();
          String prettyJson = prettyPrint.toJson(viewRefund);

          System.out.println(prettyJson);
      }
  }
  ```

  ```python Python   theme={null}
  from pprint import pprint
  import mangopay

  mangopay.client_id='your-client-id'
  mangopay.apikey='your-api-key'

  from mangopay.api import APIRequest
  handler = APIRequest(sandbox=True)

  from mangopay.resources import Refund

  refund_id = '214572035'

  try:
      view_refund = Refund.get(refund_id)
      pprint(vars(view_refund))
  except Refund.DoesNotExist:
      print('The Refund {} does not exist.'.format(view_refund.id))  
  ```

  ```csharp .NET  theme={null}
  using MangoPay.SDK;
  using Newtonsoft.Json;

  class Program
  {
      static async Task Main(string[] args)
      {
          MangoPayApi api = new MangoPayApi();

          api.Config.ClientId = "your-client-id";
          api.Config.ClientPassword = "your-api-key";

          var viewRefund = await api.Refunds.GetAsync("refund_m_01J3ZJ85JAQBYTJ8SBD8ZYNBV2");

          string prettyPrint = JsonConvert.SerializeObject(viewRefund, Formatting.Indented);
          Console.WriteLine(prettyPrint);
      }
  }
  ```
</RequestExample>
